<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>iipsrv: Cache Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="iip.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">iipsrv
   &#160;<span id="projectnumber">1.1</span>
   </div>
   <div id="projectbrief">iipsrv is an advanced high-performance feature-rich image server for web-based streamed viewing and zooming of ultra high-resolution images</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classCache.html','');});
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classCache-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Cache Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><a class="el" href="classCache.html" title="Cache to store raw tile data. ">Cache</a> to store raw tile data.  
 <a href="classCache.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="Cache_8h_source.html">Cache.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a0947492d8c2a38b588185e2213f4f6ed"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCache.html#a0947492d8c2a38b588185e2213f4f6ed">Cache</a> (float max)</td></tr>
<tr class="memdesc:a0947492d8c2a38b588185e2213f4f6ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a0947492d8c2a38b588185e2213f4f6ed">More...</a><br /></td></tr>
<tr class="separator:a0947492d8c2a38b588185e2213f4f6ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8b171a6c49d88d3ba179477484b9d48"><td class="memItemLeft" align="right" valign="top"><a id="af8b171a6c49d88d3ba179477484b9d48"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCache.html#af8b171a6c49d88d3ba179477484b9d48">~Cache</a> ()</td></tr>
<tr class="memdesc:af8b171a6c49d88d3ba179477484b9d48"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:af8b171a6c49d88d3ba179477484b9d48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaadc276ecc25d2e9270410c36d2a733e"><td class="memItemLeft" align="right" valign="top"><a id="aaadc276ecc25d2e9270410c36d2a733e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCache.html#aaadc276ecc25d2e9270410c36d2a733e">clear</a> ()</td></tr>
<tr class="memdesc:aaadc276ecc25d2e9270410c36d2a733e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Empty the cache. <br /></td></tr>
<tr class="separator:aaadc276ecc25d2e9270410c36d2a733e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9974a22953e338a60f37ef92e5937fa"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCache.html#aa9974a22953e338a60f37ef92e5937fa">insert</a> (const <a class="el" href="classRawTile.html">RawTile</a> &amp;r)</td></tr>
<tr class="memdesc:aa9974a22953e338a60f37ef92e5937fa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insert a tile.  <a href="#aa9974a22953e338a60f37ef92e5937fa">More...</a><br /></td></tr>
<tr class="separator:aa9974a22953e338a60f37ef92e5937fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5cd9c3810888ad2fb784491ee9961d0e"><td class="memItemLeft" align="right" valign="top"><a id="a5cd9c3810888ad2fb784491ee9961d0e"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCache.html#a5cd9c3810888ad2fb784491ee9961d0e">getNumElements</a> ()</td></tr>
<tr class="memdesc:a5cd9c3810888ad2fb784491ee9961d0e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the number of tiles in the cache. <br /></td></tr>
<tr class="separator:a5cd9c3810888ad2fb784491ee9961d0e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2398d519f59fe27b278e5ab2cd9d9b50"><td class="memItemLeft" align="right" valign="top"><a id="a2398d519f59fe27b278e5ab2cd9d9b50"></a>
float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCache.html#a2398d519f59fe27b278e5ab2cd9d9b50">getMemorySize</a> ()</td></tr>
<tr class="memdesc:a2398d519f59fe27b278e5ab2cd9d9b50"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the number of MB stored. <br /></td></tr>
<tr class="separator:a2398d519f59fe27b278e5ab2cd9d9b50"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adf2e22afaf201cfeaef52f1bb1e78c8c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classRawTile.html">RawTile</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCache.html#adf2e22afaf201cfeaef52f1bb1e78c8c">getTile</a> (std::string f, int r, int t, int h, int v, CompressionType c, int q)</td></tr>
<tr class="memdesc:adf2e22afaf201cfeaef52f1bb1e78c8c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a tile from the cache.  <a href="#adf2e22afaf201cfeaef52f1bb1e78c8c">More...</a><br /></td></tr>
<tr class="separator:adf2e22afaf201cfeaef52f1bb1e78c8c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab33f2789c54cf9b07625ad566f079ade"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCache.html#ab33f2789c54cf9b07625ad566f079ade">getIndex</a> (std::string f, int r, int t, int h, int v, CompressionType c, int q)</td></tr>
<tr class="memdesc:ab33f2789c54cf9b07625ad566f079ade"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a hash index.  <a href="#ab33f2789c54cf9b07625ad566f079ade">More...</a><br /></td></tr>
<tr class="separator:ab33f2789c54cf9b07625ad566f079ade"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p><a class="el" href="classCache.html" title="Cache to store raw tile data. ">Cache</a> to store raw tile data. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a0947492d8c2a38b588185e2213f4f6ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0947492d8c2a38b588185e2213f4f6ed">&#9670;&nbsp;</a></span>Cache()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Cache::Cache </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>max</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">max</td><td>Maximum cache size in MB </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ab33f2789c54cf9b07625ad566f079ade"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab33f2789c54cf9b07625ad566f079ade">&#9670;&nbsp;</a></span>getIndex()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string Cache::getIndex </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>f</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>v</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">CompressionType&#160;</td>
          <td class="paramname"><em>c</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>q</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create a hash index. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">f</td><td>filename </td></tr>
    <tr><td class="paramname">r</td><td>resolution number </td></tr>
    <tr><td class="paramname">t</td><td>tile number </td></tr>
    <tr><td class="paramname">h</td><td>horizontal sequence number </td></tr>
    <tr><td class="paramname">v</td><td>vertical sequence number </td></tr>
    <tr><td class="paramname">c</td><td>compression type </td></tr>
    <tr><td class="paramname">q</td><td>compression quality </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>string </dd></dl>

<p class="reference">Referenced by <a class="el" href="classCache.html#adf2e22afaf201cfeaef52f1bb1e78c8c">getTile()</a>, and <a class="el" href="classCache.html#aa9974a22953e338a60f37ef92e5937fa">insert()</a>.</p>

</div>
</div>
<a id="adf2e22afaf201cfeaef52f1bb1e78c8c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adf2e22afaf201cfeaef52f1bb1e78c8c">&#9670;&nbsp;</a></span>getTile()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classRawTile.html">RawTile</a>* Cache::getTile </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>f</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>v</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">CompressionType&#160;</td>
          <td class="paramname"><em>c</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>q</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get a tile from the cache. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">f</td><td>filename </td></tr>
    <tr><td class="paramname">r</td><td>resolution number </td></tr>
    <tr><td class="paramname">t</td><td>tile number </td></tr>
    <tr><td class="paramname">h</td><td>horizontal sequence number </td></tr>
    <tr><td class="paramname">v</td><td>vertical sequence number </td></tr>
    <tr><td class="paramname">c</td><td>compression type </td></tr>
    <tr><td class="paramname">q</td><td>compression quality </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pointer to data or NULL on error </dd></dl>

<p class="reference">References <a class="el" href="classCache.html#ab33f2789c54cf9b07625ad566f079ade">getIndex()</a>.</p>

</div>
</div>
<a id="aa9974a22953e338a60f37ef92e5937fa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa9974a22953e338a60f37ef92e5937fa">&#9670;&nbsp;</a></span>insert()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Cache::insert </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>r</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Insert a tile. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">r</td><td>Tile to be inserted </td></tr>
  </table>
  </dd>
</dl>

<p class="reference">References <a class="el" href="classRawTile.html#ac91c2369d082758d84e14e665ef89e50">RawTile::compressionType</a>, <a class="el" href="classRawTile.html#ab3347b1e277e6a9ae76e586bc2039f1e">RawTile::dataLength</a>, <a class="el" href="classRawTile.html#a1e0d331e87d42ba80b068c3c6da3eca6">RawTile::filename</a>, <a class="el" href="classCache.html#ab33f2789c54cf9b07625ad566f079ade">getIndex()</a>, <a class="el" href="classRawTile.html#adf557b561ec0c2e012cdeaac7618ea07">RawTile::hSequence</a>, <a class="el" href="classRawTile.html#ad75ec271caaf53e42caafadca3ceb066">RawTile::quality</a>, <a class="el" href="classRawTile.html#a9bfdf53386b287f7c3fc6f55b34c7dc2">RawTile::resolution</a>, <a class="el" href="classRawTile.html#a994e9e3a386bd44ceacd25f54ceacee4">RawTile::tileNum</a>, <a class="el" href="classRawTile.html#a5155d752cc69c6a5b1ca80d4bc5f263b">RawTile::timestamp</a>, and <a class="el" href="classRawTile.html#a5bf652f813c72cfe6b095880da27d8d0">RawTile::vSequence</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="Cache_8h_source.html">Cache.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classCache.html">Cache</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.14 </li>
  </ul>
</div>
</body>
</html>
